### Virtual Method

# Gio File query_filesystem_info

#### Declaration [src]

    GFileInfo*
    query_filesystem_info (
      GFile* file,
      const char* attributes,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Similar to g_file_query_info(), but obtains information about the filesystem the `file` is on, rather than the file itself. For instance the amount of space available and the type of the filesystem.

The `attributes` value is a string that specifies the attributes that should be gathered. It is not an error if it’s not possible to read a particular requested attribute from a file - it just won’t be set. `attributes` should be a comma-separated list of attributes or attribute wildcards. The wildcard “*” means all attributes, and a wildcard like “filesystem::*” means all attributes in the filesystem namespace. The standard namespace for filesystem attributes is “filesystem”. Common attributes of interest are `G_FILE_ATTRIBUTE_FILESYSTEM_SIZE` (the total size of the filesystem in bytes), `G_FILE_ATTRIBUTE_FILESYSTEM_FREE` (number of bytes available), and `G_FILE_ATTRIBUTE_FILESYSTEM_TYPE` (type of the filesystem).

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

If the file does not exist, the `G_IO_ERROR_NOT_FOUND` error will be returned. Other errors are possible too, and depend on what kind of filesystem the file is on.

#### Parameters

`attributes`

  Type: `const char*`

  An attribute query string.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileInfo`

A `GFileInfo` or `NULL` if there was an error. Free the returned object with g_object_unref().

The caller of the method takes ownership of the returned data, and is responsible for freeing it.